Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Asynch_Read_File Class Reference

This class is a factory for starting off asynchronous reads on a file. This class forwards all methods to its implementation class. More...

`#include <Asynch_IO.h>`

Inheritance diagram for ACE_Asynch_Read_File:

[legend]
Collaboration diagram for ACE_Asynch_Read_File:

[legend]
List of all members.

## Public Methods
| ACE_Asynch_Read_File (void)
| A do nothing constructor. More...
virtual | ~ACE_Asynch_Read_File (void)
| Destructor. More...
int | open (ACE_Handler &handler, ACE_HANDLE handle=ACE_INVALID_HANDLE, const void *completion_key=0, ACE_Proactor *proactor=0)
int | read (ACE_Message_Block &message_block, size_t bytes_to_read, u_long offset=0, u_long offset_high=0, const void *act=0, int priority=0, int signal_number=ACE_SIGRTMIN)
int | readv (ACE_Message_Block &message_block, size_t bytes_to_read, u_long offset=0, u_long offset_high=0, const void *act=0, int priority=0, int signal_number=ACE_SIGRTMIN)
ACE_Asynch_Read_File_Impl * | implementation (void) const
| Return the underlying implementation class. More...
## Protected Methods
void | implementation (ACE_Asynch_Read_File_Impl *implementation)
| Set the implementation class. More...
## Protected Attributes
ACE_Asynch_Read_File_Impl * | implementation_
| Delegation/implementation class that all methods will be forwarded to. More...

## Detailed Description

This class is a factory for starting off asynchronous reads on a file. This class forwards all methods to its implementation class.

Once <open> is called, multiple asynchronous <read>s can started using this class. An ACE_Asynch_Read_File::Result will be passed back to the <handler> when the asynchronous reads completes through the <ACE_Handler::handle_read_file> callback. This class differs slightly from ACE_Asynch_Read_Stream as it allows the user to specify an offset for the read.

## Constructor & Destructor Documentation

ACE_Asynch_Read_File::ACE_Asynch_Read_File | ( | void |  | ) |

| A do nothing constructor.

ACE_Asynch_Read_File::~ACE_Asynch_Read_File | ( | void |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

void ACE_Asynch_Read_File::implementation | ( | ACE_Asynch_Read_File_Impl * | implementation | ) | `[protected]`

| Set the implementation class.

ACE_Asynch_Read_File_Impl * ACE_Asynch_Read_File::implementation | ( | void |  | ) | const

| Return the underlying implementation class. Reimplemented from ACE_Asynch_Read_Stream.

int ACE_Asynch_Read_File::open | ( | ACE_Handler & | handler,
|  | ACE_HANDLE | handle = ACE_INVALID_HANDLE,
|  | const void * | completion_key = 0,
|  | ACE_Proactor * | proactor = 0
| ) |

| Initializes the factory with information which will be used with each asynchronous call. If (<handle> == ACE_INVALID_HANDLE), <ACE_Handler::handle> will be called on the <handler> to get the correct handle. Reimplemented from ACE_Asynch_Read_Stream.

int ACE_Asynch_Read_File::read | ( | ACE_Message_Block & | message_block,
|  | size_t | bytes_to_read,
|  | u_long | offset = 0,
|  | u_long | offset_high = 0,
|  | const void * | act = 0,
|  | int | priority = 0,
|  | int | signal_number = ACE_SIGRTMIN
| ) |

| This starts off an asynchronous read. Upto <bytes_to_read> will be read and stored in the <message_block>. The read will start at <offset> from the beginning of the file. Priority of the operation is specified by <priority>. On POSIX4-Unix, this is supported. Works like <nice> in Unix. Negative values are not allowed. 0 means priority of the operation same as the process priority. 1 means priority of the operation is one less than process. And so forth. On Win32, this argument is a no-op. <signal_number> is the POSIX4 real-time signal number to be used for the operation. <signal_number> ranges from ACE_SIGRTMIN to ACE_SIGRTMAX. This argument is a no-op on non-POSIX4 systems.

int ACE_Asynch_Read_File::readv | ( | ACE_Message_Block & | message_block,
|  | size_t | bytes_to_read,
|  | u_long | offset = 0,
|  | u_long | offset_high = 0,
|  | const void * | act = 0,
|  | int | priority = 0,
|  | int | signal_number = ACE_SIGRTMIN
| ) |

| Same as above but with scatter support, through chaining of composite message blocks using the continuation field. NOTE: In win32 Each data block payload must be at least the size of a system memory page and must be aligned on a system memory page size boundary

## Member Data Documentation

ACE_Asynch_Read_File_Impl* ACE_Asynch_Read_File::implementation_`[protected]`

| Delegation/implementation class that all methods will be forwarded to. Reimplemented from ACE_Asynch_Read_Stream.

The documentation for this class was generated from the following files:

- Asynch_IO.h
- Asynch_IO.cpp